package net.psammead.mwapi.ui.action.response;

import net.psammead.util.*;

/** a pattern matching responses */
public class ResponsePattern {
	public static final int		WILD_CODE		= -1;
	public static final String	WILD_PATTERN	= null;
	
	public final int	code;
	public final String	pattern;
	
	public ResponsePattern() {
		this(WILD_CODE, WILD_PATTERN);
	}
	
	public ResponsePattern(int code) {
		this(code, WILD_PATTERN);
	}
	
	public ResponsePattern(String pattern) {
		this(WILD_CODE, pattern);
	}
	
	public ResponsePattern(int code, String pattern) {
		this.code		= code;
		this.pattern	= pattern;
	}
	
	public boolean match(int responseCode, String responseBody) {
		return (code    == WILD_CODE    || code == responseCode)
			&& (pattern == WILD_PATTERN || match(responseBody));
	}

	private boolean match(String responseBody) {
		// TODO: decoding entities here is a bit of a hack..
		String	decoded	= XMLCodec.decodeBody(responseBody);
		//System.err.println("??? ResponsePattern match: " + pattern);
		boolean	matches	= decoded.matches(pattern);
		//System.err.println("??? ResponsePattern result: " + matches);
		return matches;
//		return XMLCodec.decodeBody(responseBody)
//						.matches(pattern);
	}
	
	/**  for debugging purposes only */
	public String toString() {
		return "ResponsePattern"
			+ "{ code="	+ code
			+ ", pattern="	+ pattern
			+ " }";
	}
}